pub enum Object<'s> {
    TextMarkup(TextMarkup<'s>),
    PlainText(PlainText<'s>),
}

pub struct TextMarkup<'s> {
    pub source: &'s str,
}

pub struct PlainText<'s> {
    pub source: &'s str,
}

pub trait Source<'s> {
    fn get_source(&'s self) -> &'s str;
}

impl<'s> Source<'s> for Object<'s> {
    fn get_source(&'s self) -> &'s str {
        match self {
            Object::TextMarkup(obj) => obj.source,
            Object::PlainText(obj) => obj.source,
        }
    }
}
